"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.converArray2String = void 0;
var React = require("react");
var sandbox_1 = require("@ice/sandbox");
var renderComponent_1 = require("./util/renderComponent");
var handleAssets_1 = require("./util/handleAssets");
var cache_1 = require("./util/cache");
var appLifeCycle_1 = require("./util/appLifeCycle");
var capturedListeners_1 = require("./util/capturedListeners");
var isEqual = require("lodash.isequal");
function converArray2String(list) {
    if (Array.isArray(list)) {
        return list.map(function (item) {
            if (Object.prototype.toString.call(item) === '[object Object]') {
                return Object.keys(item).map(function (key) { return key + ":" + item[key]; }).join(',');
            }
            return item;
        }).join(',');
    }
    return String(list);
}
exports.converArray2String = converArray2String;
/**
 * Get app config from AppRoute props
 */
function getAppConfig(appRouteProps) {
    var appConfig = { path: '' };
    var uselessList = ['onAppEnter', 'onAppLeave', 'triggerLoading', 'triggerError'];
    Object.keys(appRouteProps).forEach(function (key) {
        if (uselessList.indexOf(key) === -1) {
            appConfig[key] = appRouteProps[key];
        }
    });
    return appConfig;
}
var AppRoute = /** @class */ (function (_super) {
    __extends(AppRoute, _super);
    function AppRoute() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            cssLoading: false,
            showComponent: false,
        };
        _this.myRefBase = null;
        _this.unmounted = false;
        _this.prevAppConfig = null;
        /**
         * get cache key
         */
        _this.getCacheKey = function (appConfig) {
            var path = (appConfig || _this.props).path;
            // use path as cache key
            return converArray2String(path);
        };
        /**
         * Load assets and render sub-application
         */
        _this.renderChild = function () {
            var _a = _this.props, rootId = _a.rootId, component = _a.component, render = _a.render;
            // cache prev app asset before load next app
            if (_this.prevAppConfig && _this.prevAppConfig.cache) {
                handleAssets_1.cacheAssets(_this.getCacheKey(_this.prevAppConfig));
            }
            // if component / render exists,
            // set showComponent to confirm capturedEventListeners triggered at the right time
            if (component || (render && typeof render === 'function')) {
                _this.triggerPrevAppLeave();
                _this.triggerOnAppEnter();
                _this.setState({ showComponent: true });
                return;
            }
            var myBase = _this.myRefBase;
            if (!myBase)
                return;
            _this.triggerPrevAppLeave();
            // reCreate rootElement to remove sub-application instance,
            // rootElement is created for render sub-application
            _this.rootElement = _this.reCreateElementInBase(rootId);
            cache_1.setCache('root', _this.rootElement);
            _this.loadNextApp();
        };
        _this.loadNextApp = function () { return __awaiter(_this, void 0, void 0, function () {
            var _a, url, entry, entryContent, title, triggerLoading, triggerError, shouldAssetsRemove, cache, sandbox, path, umd, name, customProps, sandboxProps, assetsCacheKey, cached, handleLoading, handleError, currentAppConfig, appAssets, urls, intervalId_1, error_1;
            var _this = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this.props, url = _a.url, entry = _a.entry, entryContent = _a.entryContent, title = _a.title, triggerLoading = _a.triggerLoading, triggerError = _a.triggerError, shouldAssetsRemove = _a.shouldAssetsRemove, cache = _a.cache, sandbox = _a.sandbox, path = _a.path, umd = _a.umd, name = _a.name, customProps = _a.customProps;
                        // set loadMode when load micro app
                        if (umd) {
                            cache_1.setCache('loadMode', 'umd');
                        }
                        else {
                            cache_1.setCache('loadMode', sandbox ? 'sandbox' : 'script');
                        }
                        if (sandbox) {
                            if (typeof sandbox === 'function') {
                                // eslint-disable-next-line new-cap
                                this.appSandbox = new sandbox();
                            }
                            else {
                                sandboxProps = typeof sandbox === 'boolean' ? {} : sandbox;
                                this.appSandbox = new sandbox_1.default(sandboxProps);
                            }
                        }
                        assetsCacheKey = this.getCacheKey();
                        cached = cache && appLifeCycle_1.isCached(assetsCacheKey);
                        // empty useless assets before loading
                        handleAssets_1.emptyAssets(shouldAssetsRemove, !cached && assetsCacheKey);
                        if (title)
                            document.title = title;
                        handleLoading = function (loading) {
                            // if AppRoute is unmounted, cancel all operations
                            if (_this.unmounted)
                                return;
                            var cssLoading = _this.state.cssLoading;
                            if (loading !== cssLoading) {
                                _this.setState({ cssLoading: loading, showComponent: false });
                                triggerLoading(loading);
                            }
                        };
                        handleError = function (errMessage) {
                            // if AppRoute is unmounted, cancel all operations
                            if (_this.unmounted)
                                return;
                            handleLoading(false);
                            triggerError(errMessage);
                        };
                        // trigger loading before handleAssets
                        !cached && handleLoading(true);
                        currentAppConfig = this.triggerOnAppEnter();
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 7, , 8]);
                        appAssets = null;
                        if (!(entry || entryContent)) return [3 /*break*/, 3];
                        return [4 /*yield*/, handleAssets_1.getEntryAssets({
                                root: this.rootElement,
                                entry: entry,
                                href: location.href,
                                entryContent: entryContent,
                                assetsCacheKey: assetsCacheKey,
                            })];
                    case 2:
                        // entry for fetch -> process -> append
                        appAssets = _b.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        if (url) {
                            urls = Array.isArray(url) ? url : [url];
                            appAssets = handleAssets_1.getUrlAssets(urls);
                        }
                        _b.label = 4;
                    case 4:
                        if (!(appAssets && !cached)) return [3 /*break*/, 6];
                        return [4 /*yield*/, handleAssets_1.appendAssets(appAssets, name || assetsCacheKey, umd, this.appSandbox)];
                    case 5:
                        _b.sent();
                        _b.label = 6;
                    case 6:
                        // if AppRoute is unmounted, or current app is not the latest app, cancel all operations
                        if (this.unmounted || this.prevAppConfig !== currentAppConfig)
                            return [2 /*return*/];
                        if (cache) {
                            // cache app lifecycle after load assets
                            appLifeCycle_1.cacheApp(assetsCacheKey);
                        }
                        if (!cache_1.getCache(appLifeCycle_1.AppLifeCycleEnum.AppEnter)) {
                            console.warn('[icestark] please trigger app mount manually via registerAppEnter, app path: ', path);
                        }
                        if (!cache_1.getCache(appLifeCycle_1.AppLifeCycleEnum.AppLeave)) {
                            console.warn('[icestark] please trigger app unmount manually via registerAppLeave, app path: ', path);
                        }
                        intervalId_1 = setInterval(function () {
                            if (cache_1.getCache(appLifeCycle_1.AppLifeCycleEnum.AppEnter)) {
                                appLifeCycle_1.callAppEnter({ container: _this.rootElement, customProps: customProps });
                                // cancel loading after handleAssets
                                handleLoading(false);
                                clearInterval(intervalId_1);
                            }
                        }, 300);
                        return [3 /*break*/, 8];
                    case 7:
                        error_1 = _b.sent();
                        handleError(error_1.message);
                        return [3 /*break*/, 8];
                    case 8: return [2 /*return*/];
                }
            });
        }); };
        _this.reCreateElementInBase = function (elementId) {
            var myBase = _this.myRefBase;
            if (!myBase)
                return;
            // remove all elements in base
            myBase.innerHTML = '';
            // create new rootElement
            var element = document.createElement('div');
            element.id = elementId;
            myBase.appendChild(element);
            return element;
        };
        /**
         * Trigger onAppLeave in AppRouter and callAppLeave(registerAppLeave callback)
         * reset this.prevAppConfig
         */
        _this.triggerPrevAppLeave = function () {
            var _a = _this.props, onAppLeave = _a.onAppLeave, triggerLoading = _a.triggerLoading, customProps = _a.customProps;
            if (_this.appSandbox) {
                _this.appSandbox.clear();
                _this.appSandbox = null;
            }
            // trigger onAppLeave
            var prevAppConfig = _this.prevAppConfig;
            if (prevAppConfig) {
                if (typeof onAppLeave === 'function')
                    onAppLeave(prevAppConfig);
                _this.prevAppConfig = null;
            }
            // reset loading state when leave app
            triggerLoading(false);
            appLifeCycle_1.callAppLeave({ customProps: customProps, container: _this.rootElement });
        };
        /**
         * Trigger onAppEnter in AppRouter
         * callAppEnter(registerAppEnter callback) will be triggered later
         * record current appConfig as this.prevAppConfig
         */
        _this.triggerOnAppEnter = function () {
            var onAppEnter = _this.props.onAppEnter;
            var currentAppConfig = getAppConfig(_this.props);
            _this.prevAppConfig = currentAppConfig;
            // trigger onAppEnter
            if (typeof onAppEnter === 'function')
                onAppEnter(currentAppConfig);
            return currentAppConfig;
        };
        return _this;
    }
    AppRoute.prototype.componentDidMount = function () {
        this.renderChild();
    };
    AppRoute.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        var _a = this.props, path = _a.path, url = _a.url, title = _a.title, rootId = _a.rootId, componentProps = _a.componentProps;
        var _b = this.state, cssLoading = _b.cssLoading, showComponent = _b.showComponent;
        // re-render and callCapturedEventListeners if componentProps is changed
        if ((nextProps.component || nextProps.render && typeof nextProps.render === 'function') &&
            !isEqual(componentProps, nextProps.componentProps)) {
            capturedListeners_1.callCapturedEventListeners();
            return true;
        }
        else if (converArray2String(path) === converArray2String(nextProps.path) &&
            converArray2String(url) === converArray2String(nextProps.url) &&
            title === nextProps.title &&
            rootId === nextProps.rootId &&
            cssLoading === nextState.cssLoading &&
            showComponent === nextState.showComponent) {
            // reRender is triggered by sub-application router / browser, call popStateListeners
            capturedListeners_1.callCapturedEventListeners();
            return false;
        }
        return true;
    };
    AppRoute.prototype.componentDidUpdate = function (prevProps) {
        var _a = this.props, path = _a.path, url = _a.url, title = _a.title, rootId = _a.rootId;
        if (converArray2String(path) !== converArray2String(prevProps.path) ||
            converArray2String(url) !== converArray2String(prevProps.url) ||
            title !== prevProps.title ||
            rootId !== prevProps.rootId) {
            this.renderChild();
        }
    };
    AppRoute.prototype.componentWillUnmount = function () {
        // Empty useless assets before unmount
        var _a = this.props, shouldAssetsRemove = _a.shouldAssetsRemove, cache = _a.cache, clearCacheRoot = _a.clearCacheRoot;
        if (cache) {
            handleAssets_1.cacheAssets(this.getCacheKey());
        }
        // empty cached assets if cache is false
        handleAssets_1.emptyAssets(shouldAssetsRemove, !cache && this.getCacheKey());
        this.triggerPrevAppLeave();
        this.unmounted = true;
        clearCacheRoot();
    };
    AppRoute.prototype.render = function () {
        var _this = this;
        var _a = this.props, component = _a.component, render = _a.render, componentProps = _a.componentProps;
        var _b = this.state, cssLoading = _b.cssLoading, showComponent = _b.showComponent;
        if (component) {
            return showComponent ? renderComponent_1.default(component, componentProps) : null;
        }
        if (render && typeof render === 'function') {
            return showComponent ? render(componentProps) : null;
        }
        return (React.createElement("div", { ref: function (element) {
                _this.myRefBase = element;
            }, className: cssLoading ? 'ice-stark-loading' : 'ice-stark-loaded' }));
    };
    AppRoute.defaultProps = {
        exact: false,
        strict: false,
        sensitive: false,
        sandbox: false,
        rootId: 'icestarkNode',
        shouldAssetsRemove: function () { return true; },
    };
    return AppRoute;
}(React.Component));
exports.default = AppRoute;
//# sourceMappingURL=AppRoute.js.map