"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.callAppLeave = exports.callAppEnter = exports.isCached = exports.deleteCache = exports.cacheApp = exports.AppLifeCycleEnum = void 0;
var cache_1 = require("./cache");
var capturedListeners_1 = require("./capturedListeners");
var AppLifeCycleEnum;
(function (AppLifeCycleEnum) {
    AppLifeCycleEnum["AppEnter"] = "appEnter";
    AppLifeCycleEnum["AppLeave"] = "appLeave";
})(AppLifeCycleEnum = exports.AppLifeCycleEnum || (exports.AppLifeCycleEnum = {}));
function cacheApp(cacheKey) {
    [AppLifeCycleEnum.AppEnter, AppLifeCycleEnum.AppLeave].forEach(function (lifeCycle) {
        var lifeCycleCacheKey = "cache_" + cacheKey + "_" + lifeCycle;
        if (cache_1.getCache(lifeCycle)) {
            cache_1.setCache(lifeCycleCacheKey, cache_1.getCache(lifeCycle));
        }
        else if (cache_1.getCache(lifeCycleCacheKey)) {
            // set cache to current lifeCycle
            cache_1.setCache(lifeCycle, cache_1.getCache(lifeCycleCacheKey));
        }
    });
}
exports.cacheApp = cacheApp;
function deleteCache(cacheKey) {
    [AppLifeCycleEnum.AppEnter, AppLifeCycleEnum.AppLeave].forEach(function (lifeCycle) {
        cache_1.setCache("cache_" + cacheKey + "_" + lifeCycle, null);
    });
}
exports.deleteCache = deleteCache;
function isCached(cacheKey) {
    return !!cache_1.getCache("cache_" + cacheKey + "_" + AppLifeCycleEnum.AppEnter);
}
exports.isCached = isCached;
function callAppEnter(props) {
    var appEnterKey = AppLifeCycleEnum.AppEnter;
    var registerAppEnterCallback = cache_1.getCache(appEnterKey);
    if (registerAppEnterCallback) {
        registerAppEnterCallback(props);
        cache_1.setCache(appEnterKey, null);
    }
}
exports.callAppEnter = callAppEnter;
function callAppLeave(props) {
    // resetCapturedEventListeners when app change, remove react-router/vue-router listeners
    capturedListeners_1.resetCapturedEventListeners();
    var appLeaveKey = AppLifeCycleEnum.AppLeave;
    var registerAppLeaveCallback = cache_1.getCache(appLeaveKey);
    if (registerAppLeaveCallback) {
        registerAppLeaveCallback(props);
        cache_1.setCache(appLeaveKey, null);
    }
}
exports.callAppLeave = callAppLeave;
//# sourceMappingURL=appLifeCycle.js.map