"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.cacheAssets = exports.checkCacheKey = exports.emptyAssets = exports.setStaticAttribute = exports.recordAssets = exports.getAssetsNode = exports.getEntryAssets = exports.processHtml = exports.getComment = exports.getUrl = exports.startWith = exports.parseUrl = exports.appendAssets = exports.fetchScripts = exports.getUrlAssets = exports.appendExternalScript = exports.appendCSS = exports.AssetCommentEnum = exports.AssetTypeEnum = void 0;
var urlParse = require("url-parse");
var appLifeCycle_1 = require("./appLifeCycle");
var cache_1 = require("./cache");
var constant_1 = require("./constant");
var message_1 = require("./message");
var umdLoader_1 = require("./umdLoader");
var winFetch = window.fetch;
var COMMENT_REGEX = /<!--.*?-->/g;
var SCRIPT_REGEX = /<script\b[^>]*>([\s\S]*?)<\/script>/gi;
var SCRIPT_SRC_REGEX = /<script\b[^>]*src=['"]?([^'"]*)['"]?\b[^>]*>/gi;
var STYLE_REGEX = /<style\b[^>]*>([^<]*)<\/style>/gi;
var LINK_HREF_REGEX = /<link\b[^>]*href=['"]?([^'"]*)['"]?\b[^>]*>/gi;
var CSS_REGEX = new RegExp([STYLE_REGEX, LINK_HREF_REGEX].map(function (reg) { return reg.source; }).join('|'), 'gi');
var STYLE_SHEET_REGEX = /rel=['"]stylesheet['"]/gi;
var moduleLoader = new umdLoader_1.default();
var AssetTypeEnum;
(function (AssetTypeEnum) {
    AssetTypeEnum["INLINE"] = "inline";
    AssetTypeEnum["EXTERNAL"] = "external";
})(AssetTypeEnum = exports.AssetTypeEnum || (exports.AssetTypeEnum = {}));
var AssetCommentEnum;
(function (AssetCommentEnum) {
    AssetCommentEnum["REPLACED"] = "replaced";
    AssetCommentEnum["PROCESSED"] = "processed";
})(AssetCommentEnum = exports.AssetCommentEnum || (exports.AssetCommentEnum = {}));
/**
 * Create link/style element and append to root
 */
function appendCSS(root, asset, id) {
    return new Promise(function (resolve, reject) {
        var _a = asset, type = _a.type, content = _a.content;
        if (!root)
            reject(new Error("no root element for css assert: " + (content || asset)));
        if (type && type === AssetTypeEnum.INLINE) {
            var styleElement = document.createElement('style');
            styleElement.innerHTML = content;
            root.appendChild(styleElement);
            resolve();
            return;
        }
        var element = document.createElement('link');
        element.setAttribute(constant_1.PREFIX, constant_1.DYNAMIC);
        element.id = id;
        element.rel = 'stylesheet';
        element.href = content || asset;
        element.addEventListener('error', function () {
            message_1.error("css asset loaded error: " + (content || asset));
            return resolve();
        }, false);
        element.addEventListener('load', function () { return resolve(); }, false);
        root.appendChild(element);
    });
}
exports.appendCSS = appendCSS;
/**
 * Create script element (without inline) and append to root
 */
function appendExternalScript(root, asset, id) {
    // return new Promise<string>((resolve, reject) => {
    var _a = asset, type = _a.type, content = _a.content;
    // if (!root) reject(new Error(`no root element for js assert: ${content || asset}`));
    var element = document.createElement('script');
    // inline script
    if (type && type === AssetTypeEnum.INLINE) {
        element.innerHTML = content;
        root.appendChild(element);
        // resolve();
        return;
    }
    element.setAttribute(constant_1.PREFIX, constant_1.DYNAMIC);
    element.id = id;
    element.type = 'text/javascript';
    element.src = content || asset;
    element.async = false;
    // element.addEventListener(
    //   'error',
    //   () => reject(new Error(`js asset loaded error: ${content || asset}`)),
    //   false,
    // );
    // element.addEventListener('load', () => resolve(), false);
    root.appendChild(element);
    // });
}
exports.appendExternalScript = appendExternalScript;
function getUrlAssets(urls) {
    var jsList = [];
    var cssList = [];
    urls.forEach(function (url) {
        // //icestark.com/index.css -> true
        // //icestark.com/index.css?timeSamp=1575443657834 -> true
        // //icestark.com/index.css?query=test.js -> false
        var isCss = constant_1.IS_CSS_REGEX.test(url);
        var assest = {
            type: AssetTypeEnum.EXTERNAL,
            content: url,
        };
        if (isCss) {
            cssList.push(assest);
        }
        else {
            jsList.push(assest);
        }
    });
    return { jsList: jsList, cssList: cssList };
}
exports.getUrlAssets = getUrlAssets;
var cachedScriptsContent = {};
function fetchScripts(jsList, fetch) {
    if (fetch === void 0) { fetch = winFetch; }
    return Promise.all(jsList.map(function (asset) {
        var type = asset.type, content = asset.content;
        if (type === AssetTypeEnum.INLINE) {
            return content;
        }
        else {
            // content will script url when type is AssetTypeEnum.EXTERNAL
            return cachedScriptsContent[content] || (cachedScriptsContent[content] = fetch(content).then(function (res) { return res.text(); }));
        }
    }));
}
exports.fetchScripts = fetchScripts;
function appendAssets(assets, cacheKey, umd, sandbox) {
    return __awaiter(this, void 0, void 0, function () {
        var jsRoot, cssRoot, jsList, cssList, moduleInfo, jsContents;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    jsRoot = document.createDocumentFragment();
                    cssRoot = document.getElementsByTagName('head')[0];
                    jsList = assets.jsList, cssList = assets.cssList;
                    // load css content
                    return [4 /*yield*/, Promise.all(cssList.map(function (asset, index) { return appendCSS(cssRoot, asset, constant_1.PREFIX + "-css-" + index); }))];
                case 1:
                    // load css content
                    _a.sent();
                    if (!umd) return [3 /*break*/, 3];
                    return [4 /*yield*/, moduleLoader.execModule({ jsList: jsList, cacheKey: cacheKey }, sandbox)];
                case 2:
                    moduleInfo = _a.sent();
                    // set app lifecycle after exec umd module
                    cache_1.setCache(appLifeCycle_1.AppLifeCycleEnum.AppEnter, moduleInfo === null || moduleInfo === void 0 ? void 0 : moduleInfo.mount);
                    cache_1.setCache(appLifeCycle_1.AppLifeCycleEnum.AppLeave, moduleInfo === null || moduleInfo === void 0 ? void 0 : moduleInfo.unmount);
                    return [3 /*break*/, 7];
                case 3:
                    if (!(sandbox && !sandbox.sandboxDisabled)) return [3 /*break*/, 5];
                    return [4 /*yield*/, fetchScripts(jsList)];
                case 4:
                    jsContents = _a.sent();
                    // excute code by order
                    jsContents.forEach(function (script) {
                        sandbox.execScriptInSandbox(script);
                    });
                    return [3 /*break*/, 7];
                case 5: 
                // const hasInlineScript = jsList.find((asset) => asset.type === AssetTypeEnum.INLINE);
                // if (hasInlineScript) {
                //   // make sure js assets loaded in order if has inline scripts
                //   await jsList.reduce((chain, asset, index) => {
                //     return chain.then(() => appendExternalScript(jsRoot, asset, `${PREFIX}-js-${index}`));
                //   }, Promise.resolve());
                // } else {
                return [4 /*yield*/, Promise.all(jsList.map(function (asset, index) { return appendExternalScript(jsRoot, asset, constant_1.PREFIX + "-js-" + index); }))];
                case 6:
                    // const hasInlineScript = jsList.find((asset) => asset.type === AssetTypeEnum.INLINE);
                    // if (hasInlineScript) {
                    //   // make sure js assets loaded in order if has inline scripts
                    //   await jsList.reduce((chain, asset, index) => {
                    //     return chain.then(() => appendExternalScript(jsRoot, asset, `${PREFIX}-js-${index}`));
                    //   }, Promise.resolve());
                    // } else {
                    _a.sent();
                    // }
                    document.body.appendChild(jsRoot);
                    _a.label = 7;
                case 7: return [2 /*return*/];
            }
        });
    });
}
exports.appendAssets = appendAssets;
function parseUrl(entry) {
    var _a = urlParse(entry), origin = _a.origin, pathname = _a.pathname;
    return {
        origin: origin,
        pathname: pathname,
    };
}
exports.parseUrl = parseUrl;
function startWith(url, prefix) {
    return url.slice(0, prefix.length) === prefix;
}
exports.startWith = startWith;
function getUrl(entry, relativePath) {
    var _a = parseUrl(entry), origin = _a.origin, pathname = _a.pathname;
    // https://icestark.com/ice/index.html + ./js/index.js -> https://icestark.com/ice/js/index.js
    if (startWith(relativePath, './')) {
        var rPath = relativePath.slice(1);
        if (!pathname || pathname === '/') {
            return "" + origin + rPath;
        }
        var pathArr = pathname.split('/');
        pathArr.splice(-1);
        return "" + origin + pathArr.join('/') + rPath;
    }
    else if (startWith(relativePath, '/')) {
        // https://icestark.com/ice/index.html + /js/index.js -> https://icestark.com/js/index.js
        return "" + origin + relativePath;
    }
    else {
        // https://icestark.com + js/index.js -> https://icestark.com/js/index.js
        return origin + "/" + relativePath;
    }
}
exports.getUrl = getUrl;
/**
 * If script/link processed by @ice/stark, add comment for it
 */
function getComment(tag, from, type) {
    return "<!--" + tag + " " + from + " " + type + " by @ice/stark-->";
}
exports.getComment = getComment;
/**
 * html -> { html: processedHtml, assets: processedAssets }
 */
function processHtml(html, entry) {
    if (!html)
        return { html: '', assets: { cssList: [], jsList: [] } };
    var processedJSAssets = [];
    var processedCSSAssets = [];
    var processedHtml = html
        .replace(COMMENT_REGEX, '')
        .replace(SCRIPT_REGEX, function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        var matchStr = args[0], matchContent = args[1];
        if (!matchStr.match(SCRIPT_SRC_REGEX)) {
            processedJSAssets.push({
                type: AssetTypeEnum.INLINE,
                content: matchContent,
            });
            return getComment('script', 'inline', AssetCommentEnum.REPLACED);
        }
        else {
            return matchStr.replace(SCRIPT_SRC_REGEX, function (_, argSrc2) {
                var url = argSrc2.indexOf('//') >= 0 ? argSrc2 : getUrl(entry, argSrc2);
                processedJSAssets.push({
                    type: AssetTypeEnum.EXTERNAL,
                    content: url,
                });
                return getComment('script', argSrc2, AssetCommentEnum.REPLACED);
            });
        }
    })
        .replace(CSS_REGEX, function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        var matchStr = args[0], matchStyle = args[1], matchLink = args[2];
        // not stylesheet, return as it is
        if (matchStr.match(STYLE_SHEET_REGEX)) {
            var url = matchLink.indexOf('//') >= 0 ? matchLink : getUrl(entry, matchLink);
            processedCSSAssets.push({
                type: AssetTypeEnum.EXTERNAL,
                content: url,
            });
            return "" + getComment('link', matchLink, AssetCommentEnum.PROCESSED);
        }
        else if (matchStyle) {
            processedCSSAssets.push({
                type: AssetTypeEnum.INLINE,
                content: matchStyle,
            });
            return getComment('style', 'inline', AssetCommentEnum.REPLACED);
        }
        return matchStr;
    });
    return {
        html: processedHtml,
        assets: {
            jsList: processedJSAssets,
            cssList: processedCSSAssets,
        },
    };
}
exports.processHtml = processHtml;
var cachedProcessedContent = {};
function getEntryAssets(_a) {
    var root = _a.root, entry = _a.entry, entryContent = _a.entryContent, assetsCacheKey = _a.assetsCacheKey, href = _a.href, _b = _a.fetch, fetch = _b === void 0 ? winFetch : _b;
    return __awaiter(this, void 0, void 0, function () {
        var cachedContent, htmlContent, res;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    cachedContent = cachedProcessedContent[assetsCacheKey];
                    if (!!cachedContent) return [3 /*break*/, 4];
                    htmlContent = entryContent;
                    if (!(!htmlContent && entry)) return [3 /*break*/, 3];
                    if (!fetch) {
                        message_1.warn('Current environment does not support window.fetch, please use custom fetch');
                        throw new Error("fetch " + entry + " error: Current environment does not support window.fetch, please use custom fetch");
                    }
                    return [4 /*yield*/, fetch(entry)];
                case 1:
                    res = _c.sent();
                    return [4 /*yield*/, res.text()];
                case 2:
                    htmlContent = _c.sent();
                    _c.label = 3;
                case 3:
                    cachedContent = processHtml(htmlContent, entry || href);
                    cachedProcessedContent[assetsCacheKey] = cachedContent;
                    _c.label = 4;
                case 4:
                    root.innerHTML = cachedContent.html;
                    return [2 /*return*/, cachedContent.assets];
            }
        });
    });
}
exports.getEntryAssets = getEntryAssets;
function getAssetsNode() {
    var nodeList = [];
    ['style', 'link', 'script'].forEach(function (tagName) {
        nodeList = __spreadArrays(nodeList, Array.from(document.getElementsByTagName(tagName)));
    });
    return nodeList;
}
exports.getAssetsNode = getAssetsNode;
/**
 * Record static assets
 */
function recordAssets() {
    // getElementsByTagName is faster than querySelectorAll
    var assetsList = getAssetsNode();
    assetsList.forEach(function (assetsNode) {
        setStaticAttribute(assetsNode);
    });
}
exports.recordAssets = recordAssets;
/**
 * If `PREFIX` is setted in `DYNAMIC` type, remain it
 */
function setStaticAttribute(tag) {
    if (tag.getAttribute(constant_1.PREFIX) !== constant_1.DYNAMIC) {
        tag.setAttribute(constant_1.PREFIX, constant_1.STATIC);
    }
    tag = null;
}
exports.setStaticAttribute = setStaticAttribute;
/**
 * Empty useless assets
 */
function emptyAssets(shouldRemove, cacheKey) {
    // remove extra assets
    var styleList = document.querySelectorAll("style:not([" + constant_1.PREFIX + "=" + constant_1.STATIC + "])");
    styleList.forEach(function (style) {
        if (shouldRemove(null, style) && checkCacheKey(style, cacheKey)) {
            style.parentNode.removeChild(style);
        }
    });
    var linkList = document.querySelectorAll("link:not([" + constant_1.PREFIX + "=" + constant_1.STATIC + "])");
    linkList.forEach(function (link) {
        if (shouldRemove(link.getAttribute('href'), link) && checkCacheKey(link, cacheKey)) {
            link.parentNode.removeChild(link);
        }
    });
    var jsExtraList = document.querySelectorAll("script:not([" + constant_1.PREFIX + "=" + constant_1.STATIC + "])");
    jsExtraList.forEach(function (js) {
        if (shouldRemove(js.getAttribute('src'), js) && checkCacheKey(js, cacheKey)) {
            js.parentNode.removeChild(js);
        }
    });
}
exports.emptyAssets = emptyAssets;
function checkCacheKey(node, cacheKey) {
    return (typeof cacheKey === 'boolean' && cacheKey)
        || !node.getAttribute('cache')
        || node.getAttribute('cache') === cacheKey;
}
exports.checkCacheKey = checkCacheKey;
/**
 * cache all assets loaded by current sub-application
 */
function cacheAssets(cacheKey) {
    var assetsList = getAssetsNode();
    assetsList.forEach(function (assetsNode) {
        // set cache key if asset attributes without prefix=static and cache
        if (assetsNode.getAttribute(constant_1.PREFIX) !== constant_1.STATIC && !assetsNode.getAttribute('cache')) {
            assetsNode.setAttribute('cache', cacheKey);
        }
    });
}
exports.cacheAssets = cacheAssets;
//# sourceMappingURL=handleAssets.js.map