import Sandbox from '@ice/sandbox';
import { Asset } from './handleAssets';
export interface StarkModule {
    cacheKey: string;
    jsList: Asset[];
    mount?: (Component: any, targetNode: HTMLElement, props?: any) => void;
    unmount?: (targetNode: HTMLElement) => void;
}
export interface ImportTask {
    [cacheKey: string]: Promise<string[]>;
}
export declare type PromiseModule = Promise<Response>;
export interface Fetch {
    (input: RequestInfo, init?: RequestInit): Promise<Response>;
}
export default class ModuleLoader {
    private importTask;
    load(starkModule: StarkModule): Promise<string[]>;
    clearTask(): void;
    execModule(starkModule: StarkModule, sandbox?: Sandbox): Promise<any>;
}
/**
 * Get globalwindow
 *
 * @export
 * @param {Sandbox} [sandbox]
 * @returns
 */
export declare function getGobalWindow(sandbox?: Sandbox): Window;
